import java.awt.*;
import java.io.*;
import java.net.*;
import java.applet.Applet;

public class Chaos extends Applet {
	Canvas drawArea;
	TextField rstartField;
	TextField rendField;
	TextField rincrField;
	Label rstartLabel;
	Label rendLabel;
	Label rincrLabel;
	Button calc;
	Button clear;
	Button sendnotes;
	TextArea scoreArea;
	Button xdata;
	Button conbut;
	Label conLabel;
	dataWindow dwind;

	String shostname;
	double ndur,nincr;
	int nnotes;
	int is_connected = 0;

	Socket sendSocket;
	DataOutputStream sockout;

	double rstartval,rendval,rincrval;

	int is_calc = 0;


//	private static Color fg = new Color((float)0.7, (float)0.8, (float)1.0);
	private static Color fg = new Color((float)0.56, (float)0.94, (float)1.0);

	public void init() {

		this.setBackground(fg);

		//Add Components to the Applet.
		GridBagLayout gridBag = new GridBagLayout();
		GridBagConstraints c = new GridBagConstraints();
		setLayout(gridBag);


		drawArea = new Canvas();
		c.gridwidth = GridBagConstraints.REMAINDER; //end of row
		c.fill = GridBagConstraints.BOTH;
		c.gridheight = 4;
		c.weightx = 1.0;
		c.weighty = 1.0;
		gridBag.setConstraints(drawArea, c);
		drawArea.setBackground(fg.white);
		add(drawArea);


		rstartLabel = new Label("  R Start value:");
		c.weightx = 0.0;
		c.weighty = 0.0;
		c.gridheight = 1;
		c.gridwidth = 1;
		c.anchor = GridBagConstraints.EAST;
		c.fill = GridBagConstraints.NONE;
		gridBag.setConstraints(rstartLabel, c);
		add(rstartLabel);

		rstartField = new TextField("2.99 ");
		rstartval = 2.99;
		c.anchor = GridBagConstraints.WEST;
		gridBag.setConstraints(rstartField, c);
		rstartField.setBackground(fg.lightGray);
		add(rstartField);


		rendLabel = new Label("  R End value:");
		c.anchor = GridBagConstraints.EAST;
		gridBag.setConstraints(rendLabel, c);
		add(rendLabel);

		rendField = new TextField("4.00 ");
		rendval = 4.0;
		c.anchor = GridBagConstraints.WEST;
		gridBag.setConstraints(rendField, c);
		rendField.setBackground(fg.lightGray);
		add(rendField);


		rincrLabel = new Label("  R Increment:");
		c.anchor = GridBagConstraints.EAST;
		gridBag.setConstraints(rincrLabel, c);
		add(rincrLabel);

		rincrField = new TextField("0.03 ");
		rincrval = 0.03; 
		c.gridwidth = GridBagConstraints.REMAINDER; //end of row
		c.anchor = GridBagConstraints.WEST;
		gridBag.setConstraints(rincrField, c);
		rincrField.setBackground(fg.lightGray);
		add(rincrField);


		c.gridwidth = 1;
		c.anchor = GridBagConstraints.WEST;
		calc = new Button("calculate");
		calc.setBackground(fg.lightGray);
		gridBag.setConstraints(calc, c);
		add(calc);

		c.gridwidth = GridBagConstraints.RELATIVE; //next to end of row
		c.anchor = GridBagConstraints.CENTER;
		clear = new Button("clear");
		clear.setBackground(fg.lightGray);
		gridBag.setConstraints(clear, c);
		add(clear);

		sendnotes = new Button("send notes");
		c.gridwidth = GridBagConstraints.REMAINDER; //end of row
		c.anchor = GridBagConstraints.EAST;
		gridBag.setConstraints(sendnotes, c);
		sendnotes.setBackground(fg.lightGray);
		sendnotes.disable();
		add(sendnotes);


		scoreArea = new TextArea(10, 60);
		c.gridwidth = GridBagConstraints.REMAINDER; //end of row
		c.fill = GridBagConstraints.BOTH;
		c.anchor = GridBagConstraints.CENTER;
		gridBag.setConstraints(scoreArea, c);
		scoreArea.setBackground(fg.lightGray);
		add(scoreArea);


		xdata = new Button("additional parameters");
		c.gridwidth = 2;
		c.fill = GridBagConstraints.NONE;
		c.anchor = GridBagConstraints.CENTER;
		gridBag.setConstraints(xdata, c);
		xdata.setBackground(fg.lightGray);
		add(xdata);


		conbut = new Button("  connect  ");
		c.gridwidth = GridBagConstraints.RELATIVE;
		c.anchor = GridBagConstraints.WEST;
		gridBag.setConstraints(conbut, c);
		conbut.setBackground(fg.lightGray);
		conbut.disable();
		add(conbut);

		conLabel = new Label("not connected...");
		c.fill = GridBagConstraints.BOTH;
		c.gridwidth = GridBagConstraints.REMAINDER;
		c.weightx = 1.0;
		c.anchor = GridBagConstraints.CENTER;
		gridBag.setConstraints(conLabel, c);
		add(conLabel);

		validate();
	}

	public boolean action(Event e, Object arg) {
		Object target = e.target;
		String text;
		Float stupid;
		Graphics dg;
		byte [] tchars = new byte[100];

		if (target == calc) {
			is_calc = 1;
			repaint();
		}

		if (target == clear) {
			scoreArea.setText("");
			dg = drawArea.getGraphics();
			dg.clearRect(0, 0, drawArea.size().width, drawArea.size().height);
			}

		if (target == sendnotes) {
		// god I can't believe the awfulness of this code
			int curindex,lastindex;

			text = scoreArea.getText();
			lastindex = text.lastIndexOf("START");
			for (curindex = 0; curindex <= lastindex; curindex = curindex) {
				try {
					text.getBytes(curindex, curindex+35, tchars, 0);
					sockout.write(tchars, 0, 35);
					sockout.flush();
				} catch (IOException ex) {
					System.err.println("Couldn't write them bytes\n");
					System.exit(1);
				} catch (StringIndexOutOfBoundsException ex) {
					System.err.println("Couldn't convert them bytes\n");
					System.exit(1);
				}
//				System.out.println(text.substring(curindex, curindex+35));
				curindex = text.indexOf("START",curindex+1);
				if (curindex == -1) curindex = lastindex + 1; // kick us out
			}
		}

		if (target == xdata) {
			if (dwind == null) {
				dwind = new dataWindow(this, "Additional Parameters");
			}
			dwind.show();
		}

		if (target == conbut) {
			if (is_connected == 0) {
				try {
					sendSocket = new Socket(shostname, 2102);
					sockout = new DataOutputStream(sendSocket.getOutputStream());
					conLabel.setText("connected!");
					conbut.setLabel("disconnect");
					sendnotes.enable();
					is_connected = 1;
				} catch (UnknownHostException ex) {
					System.err.println("problem connecting to host\n");
					System.exit(1);
				} catch (IOException ex) {
					System.err.println("Couldn't get I/O for the connection\n");
					System.exit(1);
				}
			}
			else {
				try {
					sockout.close();
					sendSocket.close();
				} catch (IOException ex) {
					System.err.println("Couldn't close the socket!");
				}
				conLabel.setText("not connected...");
				conbut.setLabel("  connect  ");
				sendnotes.disable();
				is_connected = 0;
			}
		}

		if (target == rstartField) {
			text = rstartField.getText();
			stupid = java.lang.Float.valueOf(text);
			rstartval = stupid.doubleValue();
		}

		if (target == rendField) {
			text = rendField.getText();
			stupid = java.lang.Float.valueOf(text);
			rendval = stupid.doubleValue();
		}

		if (target == rincrField) {
			text = rincrField.getText();
			stupid = java.lang.Float.valueOf(text);
			rincrval = stupid.doubleValue();
		}

		return true;
	}


	public void paint(Graphics g) {
		Graphics dg;

		if (is_calc == 1) {
			dg = drawArea.getGraphics();
			int gwidth,gheight;
			double fincr;
			int endincs;
			int i,j;
			double Rval,Xval;
			double curx;
			int xpt,ypt;
			double start,freq;

			gwidth = drawArea.size().width;
			gheight = drawArea.size().height;
			endincs = (int)((rendval-rstartval)/rincrval);
			fincr = (double)gwidth/(double)endincs;

			Rval = rstartval;
			Xval = 0.78;
			curx = 0.0;
			start = 0.0;
			for (j = 0; j < endincs; j++) {
				for (i = 0; i < 50; i++) Xval = (Rval*Xval)*(1.0-Xval);
				for (i = 0; i < 20; i++) {
					Xval = (Rval*Xval)*(1.0-Xval);
					xpt = (int)curx;
					ypt = (int)(Xval * (double)gheight);
					ypt = gheight - ypt;
					dg.setColor(fg.blue);
					dg.drawLine(xpt,ypt, xpt+(int)fincr,ypt);
				}
				for (i = 0; i < nnotes; i++) {
					Xval = (Rval*Xval)*(1.0-Xval);
					xpt = (int)curx;
					ypt = (int)(Xval * (double)gheight);
					ypt = gheight - ypt;
					dg.setColor(fg.red);
					dg.drawLine(xpt,ypt, xpt+(int)fincr,ypt);
					freq = Xval * 1000.0;
					scoreArea.appendText("START(" + start + ", " + ndur + ", " + freq + ", " + ndur + ", " + ndur*0.5 + ", 7000.0, 1.0)\n");
				}
				Rval += rincrval;
				curx += fincr;
				start += nincr;
			}
			is_calc = 0;
		}
	}
}


class dataWindow extends Frame {
	TextField hnameField;
	TextField nnotesField;
	TextField notedurField;
	TextField notetimeField;
	Label hnameLabel;
	Label nnotesLabel;
	Label notedurLabel;
	Label notetimeLabel;
	Chaos Ch;
	Button done;

	dataWindow(Chaos caller, String title) {
		super(title);
		Ch = caller;

		GridBagLayout gridBag = new GridBagLayout();
		GridBagConstraints c = new GridBagConstraints();
		setLayout(gridBag);


		hnameLabel = new Label("Enter RTcmix/sound server name:");
		c.anchor = GridBagConstraints.EAST;
		c.gridwidth = 1;
		gridBag.setConstraints(hnameLabel, c);
		add(hnameLabel);

		hnameField = new TextField(50);
		c.gridwidth = GridBagConstraints.REMAINDER; //end of row
		c.anchor = GridBagConstraints.WEST;
		gridBag.setConstraints(hnameField, c);
		add(hnameField);


		nnotesLabel = new Label("Enter number of notes for each step:");
		c.anchor = GridBagConstraints.EAST;
		c.gridwidth = 1;
		gridBag.setConstraints(nnotesLabel, c);
		add(nnotesLabel);

		nnotesField = new TextField("4    ");
		Ch.nnotes = 4;
		c.gridwidth = GridBagConstraints.REMAINDER; //end of row
		c.anchor = GridBagConstraints.WEST;
		gridBag.setConstraints(nnotesField, c);
		add(nnotesField);


		notedurLabel = new Label("Enter note duration:");
		c.anchor = GridBagConstraints.EAST;
		c.gridwidth = 1;
		gridBag.setConstraints(notedurLabel, c);
		add(notedurLabel);

		notedurField = new TextField("0.2  ");
		Ch.ndur = 0.2;
		c.gridwidth = GridBagConstraints.REMAINDER; //end of row
		c.anchor = GridBagConstraints.WEST;
		gridBag.setConstraints(notedurField, c);
		add(notedurField);


		notetimeLabel = new Label("Enter note timing:");
		c.anchor = GridBagConstraints.EAST;
		c.gridwidth = 1;
		gridBag.setConstraints(notetimeLabel, c);
		add(notetimeLabel);

		notetimeField = new TextField("0.1  ");
		Ch.nincr = 0.1;
		c.anchor = GridBagConstraints.WEST;
		c.gridwidth = GridBagConstraints.REMAINDER; //end of row
		gridBag.setConstraints(notetimeField, c);
		add(notetimeField);


		done = new Button("done");
		c.gridwidth = 1;
		c.anchor = GridBagConstraints.CENTER;
		gridBag.setConstraints(done, c);
		add(done);

		pack();
	}

	public boolean action(Event e, Object arg) {
		Object target = e.target;
		String text;
		Float stupid;
		Integer istupid;

		if (target == hnameField) {
			Ch.shostname = hnameField.getText();
			Ch.conbut.enable();
		}

		if (target == nnotesField) {
			text = nnotesField.getText();
			istupid = java.lang.Integer.valueOf(text);
			Ch.nnotes = istupid.intValue();
		}

		if (target == notedurField) {
			text = notedurField.getText();
			stupid = java.lang.Float.valueOf(text);
			Ch.ndur = stupid.doubleValue();
		}

		if (target == notetimeField) {
			text = notetimeField.getText();
			stupid = java.lang.Float.valueOf(text);
			Ch.nincr = stupid.doubleValue();
		}

		if (target == done) {
			hide();
		}
		return true;
	}
}

