#include <stdio.h>
#include <math.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <errno.h>

#include "/musr/cmix/Minc/sockdefs.h"
#include "../../lib/RTsockfuncs.h"


main ()
{
	int sin,nsin,len;
	int err;
	int theSock; /* RTcmix socket */
	int RTpid;
	struct sockaddr_in sssin;
	char arr[35];
	float f1,f2,f3,f4,f5;
	float pchval;
	float octcps(float);
	float pchoct(float);

	/* start up the instrument */
	RTpid = RTopensocket(0, "CMIX");
	sleep(3); /* allow the process time to start */

	/* open up the socket */
	theSock = RTsock("localhost", 0);

	/* set up the instrument */
	RTsendsock("rtsetparams", theSock, 2, 22050.0, 1.0);
	RTsendsock("print_off", theSock, 0);
	RTsendsock("load", theSock, 1, "STRUM");


	/* set up as server now...*/
	/* create the socket for listening */
	if( (sin = socket(AF_INET, SOCK_STREAM, 0)) < 0) {
		perror("socket");
		exit(1);
	}

	/* set up the socket address */
	sssin.sin_family = AF_INET;
	sssin.sin_addr.s_addr = INADDR_ANY;
	sssin.sin_port = htons(2102);

	if( err = bind(sin, (struct sockaddr *)&sssin, sizeof(sssin)) < 0) {
		perror("bind");
		exit(1);
	}

	listen(sin, 1);

	len = sizeof(sssin);
	nsin = accept(sin, (struct sockaddr *)&sssin, &len);
	if(nsin < 0) {
		perror("accept");
		exit(1);
	}
	else {
		while (1) {
			err = read(nsin, arr, 35);
			if (err <= 0) {
				RTkillsocket(theSock, RTpid);
				exit(1);
			}
			while (err < 35)
				err += read(nsin, (void *)(arr+err), 35-err);

			sscanf(arr,"START(%f, %f, %f, %f, %f",&f1,&f2,&f3,&f4,&f5);
			pchval = pchoct(octcps(f3));
			if ( (pchval > 6.00) && (pchval < 12.00) ) {
				RTsendsock("START", theSock, 8, f1, f2, pchval, 0.2, 0.1, 7000.0, 1.0, 1.0);
			}
		}
	}
}



float pchoct(float oct)
{
	float x;
	x = (int)oct;
	return(.12 * (oct - x) + x);
}

float octcps(float cps)
{
	return(log(cps/1.021975)/.69314718);

	/* .69etc is log of 2., 1.02etc is offset for middle C */
}
